%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Angle = Shell_Element_Angle(Ref_Node, Element_ID)

global ErrCode;

global DB_NODES;
global DB_ELEMENTS;

global AT_NODES;
global AT_ELEMENTS;

Angle = [];

% Проверка принадлежности референсного узла элементу
[member_flag, location] = ismember(Ref_Node, DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes);

if (~member_flag)
    fprintf (1, '\nОшибка функции Shell_Element_Angle: референсный узел %i не принадлежит элементу %i !\n', Ref_Node, Element_ID);
    ErrCode = -1;
    return;
end

% Ветвление по типу элемента
switch DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.type
    
    case {'Quad', 'Tria'}
                
        switch DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.N_nodes
            
            case 3
                                
                switch location
                    case 1
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
                    case 2
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
                    case 3
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
                end
                
            case 4
                                
                switch location
                    case 1
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
                    case 2
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
                    case 3
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
                    case 4
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location;
                end
                
            case 6
                                
                switch location
                    case 1
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(6))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
                    case 2
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(5))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
                    case 3
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(6))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(5))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
                    case {4, 5, 6}
                        fprintf (1, '\nОшибка функции Shell_Element_Angle: некорректное расположение референсного узла в квадратичном элементе с номером %i !\n', Element_ID);
                        ErrCode = -1;
                        return;
                end
                
            case 8
                                
                switch location
                    case 1
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(5))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(8))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
                    case 2
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(6))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(5))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
                    case 3
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(7))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(6))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
                    case 4
                        Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(8))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location;
                        Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(7))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location;
                    case {5,6,7,8}
                        fprintf (1, '\nОшибка функции Shell_Element_Angle: некорректное расположение референсного узла в квадратичном элементе с номером %i !\n', Element_ID);
                        ErrCode = -1;
                        return;
                end
                
        end
        
        Angle = acosd(dot(Vector_1, Vector_2)/(norm(Vector_1)*norm(Vector_2)));
    
    case {'Tet', 'Wedge', 'Hex', 'Bar'}
        
        fprintf (1, '\nОшибка функции Shell_Element_Angle: аргументы функции ссылаются на неправильный тип элемента с номером %i [%s] !\n', Element_ID, DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.type);
        ErrCode = -1;
        return;
        
    otherwise
        
        fprintf (1, '\nОшибка функции Shell_Element_Angle: неизвестный тип элемента с номером %i [%s] !\n', Element_ID, DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.type);
        ErrCode = -1;
        return;
    
end
